import java.util.concurrent.*;

public class Main3 {

   private static void nap(int millisecs) {
        try {
            Thread.sleep(millisecs);
        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
    }

    private static void addProc(JDisplay2 d, Semaphore sem) {
	int i=0;
	while(true) {
	    if (i > 10) nap((int)(Math.random() * 1500));
	    try {
		sem.acquire();
	    } catch (Exception e) {
            System.err.println(e.getMessage());
        }
	    if(i%2==0) d.addRow("AAAAAAAAAAAAAAAAAAAAAAAAA  "+(100+i));
	    else d.addRow("BBBBBBBBBBBBBBBBBBBBBBBBB  "+(100+i));
	    sem.release();
	    i++;
	}
    }

    private static void deleteProc(JDisplay2 d, Semaphore sem) {
	nap(10000);
	while(true) {
	    nap((int)(Math.random() * 3500));
	    try {
		sem.acquire();
	    } catch (Exception e) {
            System.err.println(e.getMessage());
        }
	    d.deleteRow(0);
	    sem.release();
	}
    }

    public static void main(String [] args) {
	final JDisplay2 d = new JDisplay2();
	final Semaphore sem = new Semaphore(1);
	

	new Thread () {
	    public void run() {
		addProc(d,sem);
	    }
	}.start();


	new Thread () {
	    public void run() {
		deleteProc(d,sem);
	    }
	}.start();

    }
}